<?php
/**********************************************************
* SMFSEO v0.01 Beta
* Written by Chris Nolan http://www.smfseo.org
* copyright (C) 2006 Chris Nolan, SMFSEO.org
**********************************************************/
$version="0.01 Beta";

$showerrors = $_GET["se"];
if ($showerrors == "1") {
	error_reporting(E_ALL);
	ini_set("display_errors", "on");
} else {
error_reporting(E_ALL & ~E_NOTICE);
}

if (ob_get_level() == 0) {
   ob_start();
}


// If SSI.php is in the same place as this file, and SMF isn't defined, this is being run standalone.
if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');
// Hmm... no SSI.php and no SMF?
elseif (!defined('SMF'))
	die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

// Force a step, defaulting to 0.
$_GET['step'] = (int) @$_GET['step']; 

show_header();

if (!$context['user']['is_admin']) {
	echo '
		<h2>SMFSEO - Reclaim the Search Engines</h2>
	     <p>Welcome to the SMFSEO installer/updater.</p>
	     <hr>
	     <p>SMFSEO is a complete suite of Search Engine Optimization tools for SMF. To learn more about SMFSEO please visit us at <a href="http://www.smfseo.org" target="_blank">www.smfseo.org</a>
		<p><span style="color:red;">You must be logged in as a forum admin to use this script</span></p>';
} else {

if (empty($_GET['debug']) && $_GET['step'] == "1") {

}

if (function_exists('doInstall' . $_GET['step']))
	call_user_func('doInstall' . $_GET['step']);
	
}

show_footer();
	
ob_end_flush();	
	
// Chris Nolan - SMFSEO - Start - Please make me beautiful
function beautifyme($text) {

	$text = strtr($text, array('&amp' => ' and ', '/' => '-', '.' => '-'));
	$text = html_entity_decode($text);
	
	static $search, $replace;
	if (!$search) {
		$search = $replace = array();
		// Get the HTML entities table into an array
		$trans = get_html_translation_table(HTML_ENTITIES);
		// Go through the entity mappings one-by-one
		foreach ($trans as $literal => $entity) {
			// Make sure we don't process any other characters such as fractions, quotes etc:
			if (ord($literal) >= 192) {
				// Get the accented form of the letter
				$search[] = $literal;
				// Get e.g. 'E' from the string '&Eacute'
				$replace[] = $entity[1];
			}
		}
	}
	str_replace($search, $replace, $text);
	
	$text = trim(preg_replace("/[^a-z \d\-]/i", "", $text));
	$text = strtr(strtolower($text), array(' ' => '-'));
	$text = preg_replace("/[\-]{2,}/", "-", $text);
	$text = rtrim($text, "-");
	if (is_numeric($text)) { $text = "number-".$text; } // numeric names would confuse everything
	return $text;
}
// Chris Nolan - SMFSEO - End - You look fantastic now


function doInstall0() {

echo '
	     <h2>SMFSEO - Reclaim the Search Engines</h2>
	     <p>Welcome to the SMFSEO installer/updater.</p>
	     <hr><form action="smfseo_install.php" method="get">
	     <p>SMFSEO is a complete suite of Search Engine Optimization tools for SMF. To learn more about SMFSEO please visit us at <a href="http://www.smfseo.org" target="_blank">www.smfseo.org</a>
	     <p style="text-align:center;"><strong>******* READ THIS *******</strong></p>
	     <p>If you have not already done so then you must also install the SMFSEO modification package through the SMF Package Manager.</p>
	     <p>Full installation instructions are included in the smfseo_install.txt file or at <a href="http://www.smfseo.org/install.html" target="_blank">www.smfseo.org/install.html</a>. Please visit us at <a href="http://www.smfseo.org" target="_blank">www.smfseo.org</a> if your require further support.
	     <p><input type="checkbox" name="eula" value="eula" style="margin:0;padding:0;width:20px;" />Check this box to accept the <a href="http://www.smfseo.org/licence.html" target="_blank">End User Licence Agreement</a>.';
	     	if ($_GET['error'] == "eula") { 
		     	echo "<br><span style=\"color:red;\">You must accept the agreement to continue</span>"; 
			} 
			echo '</p>
	     <p>This installer file will modify your SMF database.</p>
	     <p>If you are happy to continue then press the Install button below.</p>
	     <p style="text-align:center;"><input type="hidden" name="step" value="1" /><input type="submit" name="submit" value="Install" /></p></form>
     
     </div>
  </div>
</body>
</html>';

}

function doInstall1() {

	global $boarddir, $sourcedir, $db_prefix, $language, $modSettings;
	if (!$_GET['eula']) {
		header("Location: smfseo_install.php?step=0&error=eula"); 
	}
  echo'<h2>SMFSEO - Reclaim the Search Engines</h2>
	     <p>Installer is running...</p>
	     <hr>';
	     ob_flush();
	     flush();
	
// Let's sniff around and see where we are.
$res = db_query('SHOW TABLES LIKE "'.$db_prefix.'topic_lookup"', __FILE__, __LINE__);
$statustopics = mysql_num_rows($res);

$res = db_query("SHOW COLUMNS FROM {$db_prefix}boards LIKE 'board_text'", __FILE__, __LINE__);
$statusboards = mysql_num_rows($res);

if ($statustopics == 0) {
	$res = db_query("CREATE TABLE {$db_prefix}topic_lookup (`ID_TOPIC` mediumint(8) NOT NULL, `ID_BOARD` smallint(5) NOT NULL, `topic_text` varchar(120) NOT NULL, PRIMARY KEY (`ID_TOPIC`), UNIQUE KEY `topic_text` (`topic_text`) )", __FILE__, __LINE__);
	if ( !$res )
		echo "Could not create the table: {$db_prefix}topic_lookup";
} else {
	$res = db_query("TRUNCATE TABLE {$db_prefix}topic_lookup", __FILE__, __LINE__);
}

if ($statusboards == 0) {
	$res = db_query("ALTER TABLE {$db_prefix}boards ADD `board_text` varchar(120) NOT NULL;", __FILE__, __LINE__);
	if ( !$res )
		echo "Could not alter the table: {$db_prefix}boards to add in the required column";
} else {
	$res = db_query("UPDATE {$db_prefix}boards SET board_text = ''", __FILE__, __LINE__);	
}

//$sql = "SELECT DISTINCT (ID_TOPIC) AS topicID, ID_BOARD, subject FROM {$db_prefix}messages GROUP BY ID_TOPIC";

$sql = "SELECT t.ID_TOPIC as topicID, t.ID_BOARD, m.subject FROM {$db_prefix}topics AS t, {$db_prefix}messages AS m WHERE t.ID_FIRST_MSG = m.ID_MSG";

$result = mysql_query($sql);

if (!$result) {
   echo "Could not successfully run query ($sql) from DB: " . mysql_error();
   exit;
}

$count = mysql_num_rows($result);
$topiccount = $count;

// Loop through each topic
for ($f = 0; $f < $count; $f++) {
	
	// Put this topic's details into $thisDetailsArray
	$thisDetailsArray = null;
	$thisDetailsArray = mysql_fetch_assoc($result);
	foreach($thisDetailsArray[$f] as $k=>$v) {
		$thisDetailsArray[$k] = stripslashes($v);
	}

	$newtopic_text = beautifyme($thisDetailsArray["subject"]);
				
	// Check to see if a topic with this topic_text already exists
	$topicchecksql = "SELECT ID_TOPIC FROM {$db_prefix}topic_lookup WHERE topic_text = '".$newtopic_text."' LIMIT 1";
	$topiccheckresult = mysql_query($topicchecksql);
	if (mysql_num_rows($topiccheckresult) > 0) {
		// topic with this name already exists, fudge it.
		$newtopic_text = $thisDetailsArray["topicID"].'-'.$newtopic_text;
	}
	
	// Print some output..
	if (!empty($_GET['debug']))	{
	echo "<br/>Topic id: " . $thisDetailsArray["topicID"] . " | Board id: " . $thisDetailsArray["ID_BOARD"] . " | Topic name: " . $thisDetailsArray["subject"] . " | New topic url: " . $newtopic_text . " | ";
	}
	
	$inserttopicsql = 'insert into '.$db_prefix.'topic_lookup (ID_TOPIC, ID_BOARD, topic_text) values ('.$thisDetailsArray["topicID"].', '.$thisDetailsArray["ID_BOARD"].', "'.$newtopic_text.'")';
		$result1 = mysql_query($inserttopicsql);
		if (!$result1) {
			if (!empty($_GET['debug']))	{
		   		//echo "Could not successfully run query $inserttopicsql from DB: " . mysql_error();
		   		echo "Update maybe? | ";
				//return false;
	   		}
			$updatetopicsql = 'update '.$db_prefix.'topic_lookup SET ID_BOARD = '.$thisDetailsArray["ID_BOARD"].', topic_text = "'.$newtopic_text.'" WHERE ID_TOPIC = '.$thisDetailsArray["topicID"];
			$result2 = mysql_query($updatetopicsql);
			if (!empty($_GET['debug']))	{
				if (!$result2) {
			   		//echo "Could not successfully run query $updatetopicsql from DB: " . mysql_error();
					echo "Ouch, something went wrong <br/>";
				} else {
					echo "Yes, updated! <br/>";
				}
			}
		} else {
			if (!empty($_GET['debug']))	{
				echo "Success! <br/>";
				ob_flush();
				flush();
			}
		}

}

$sql = "SELECT ID_BOARD, name FROM {$db_prefix}boards";

$result = mysql_query($sql);

if (!$result) {
   echo "Could not successfully run query ($sql) from DB: " . mysql_error();
   exit;
}

$count = mysql_num_rows($result);
$boardcount = $count;

// Loop through each board
for ($f = 0; $f < $count; $f++) {
	
	// Put this board's details into $thisDetailsArray
	$thisDetailsArray = null;
	$thisDetailsArray = mysql_fetch_assoc($result);
	foreach($thisDetailsArray[$f] as $k=>$v) {
		$thisDetailsArray[$k] = stripslashes($v);
	}

	$newboard_text = beautifyme($thisDetailsArray["name"]);

	// Check to see if a board with this board_text already exists
	$boardchecksql = "SELECT ID_BOARD FROM {$db_prefix}boards WHERE board_text = '".$newboard_text."' LIMIT 1";
	$boardcheckresult = mysql_query($boardchecksql);
	if (mysql_num_rows($boardcheckresult) > 0) {
		// board with this name already exists, fudge it.
		$newboard_text = $thisDetailsArray["ID_BOARD"].'-'.$newboard_text;
	}
	
	// Print some output..
	if (!empty($_GET['debug']))	{
		echo "<br/>Board id: " . $thisDetailsArray["ID_BOARD"] . " | Old board name: " . $thisDetailsArray["name"] . " | New board text: " . $newboard_text . " | ";
	}
	
	$updateboardsql = 'update '.$db_prefix.'boards SET board_text = "'.$newboard_text.'" WHERE ID_BOARD = '.$thisDetailsArray["ID_BOARD"];
	$result2 = mysql_query($updateboardsql);
	if (!empty($_GET['debug']))	{
		if (!$result2) {
	   		echo "Could not successfully run query $updateboardsql from DB: " . mysql_error();
			echo "Ouch, something went wrong <br/>";
		} else {
			echo "Yes, updated! <br/>";
			ob_flush();
			flush();
		}
	}


}

echo "<p/><strong>Finished!</strong> I found ".$topiccount." topics in ".$boardcount." boards.<br/>";

echo '<p/>If you have not already done so you must now install the SMFSEO modification package using the SMF Package Manager.<p/>Full instructions are in the readme.txt or please visit us at <a href="http://www.smfseo.org">www.smfseo.org</a> for support.';

}



function show_header()
{
	global $version;
	echo'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
  <meta name="description" content="Seo your free smf opensorce forum software with our tricks and hacks to get your forum off to a good start and to increase your traffic and revenue" />
  <link rel="stylesheet" type="text/css" href="http://www.smfseo.org/install.css" media="screen,projection" />
  <title>SMF SEO - Welcome to the SMFSEO installer/updater '.$version.'</title>
</head>

<body>
  <div id="wrap">

     <div id="content">
';
	
}


function show_footer()
{
echo '  
     </div>
  </div>
  <div id="footer">
    <p>Seo url\'s funded by a <a href="http://www.mortgagesearchlive.com/">mortgage</a> 
      broker | implemented by the <a href="http://mytreo.net/">treo</a> smart 
      phone guy.<br>

      &copy; 2006, <a href="http://www.smfseo.org/">SMFSEO.org</a>. All Rights 
      Reserved. </p>
    <p>&nbsp;</p>
    <p>Please note that all trademarks belong to their respective owners and we 
      are not affiliated with Smf, Lewis Media or Simple machines in any way other 
      than providing hacks which we reserve the right on.</p>
    <p>When we submit a hack to simple machines we keep ownership of the code 
      changes made and will pursue any copy rite breach in a court of law. 
  </div>
</body>
</html>
';
	
}
?>